//Andnotor, developpez.net Defi N5 Sudoku solver
//------------------------------------------------------------------------------
//Fiche d'affichage des textes
//Les caractres sont affichs un  un  travers un timer
//------------------------------------------------------------------------------
unit Display;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Math;

type
  TfDisplay = class(TForm)
    Memo1: TMemo;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    Buffer :string;    //Buffer de caractres
  public
    //Ajoute un texte avec ventuellement effacement pralable
    procedure Write(const aText :string; aClear :boolean = FALSE);

    //Ajoute un texte avec saut de ligne et ventuellement effacement pralable
    procedure WriteLn(const aText :string; aClear :boolean = FALSE);

    //Ajoute la dure (formatte) de rsolution
    procedure WriteTime(aSuffixText :string; aTime :extended);

    //Efface le mmo
    procedure Clear;
  end;

var
  fDisplay: TfDisplay;

//------------------------------------------------------------------------------
//Les diffrents textes

ResourceString
  sPoweringON           = 'Powering ON';
  sHelloDave            = 'Hello Dave'#13#13'Press PLAY to start';
  sOpeningSudokuPad     = 'Opening pad... ';
  sClosingSudokuPad     = 'Closing pad... ';
  sSudokuPadClosed      = 'Sudoku pad closed';
  sActivateControls     = 'Activating controls... ';
  sDesactivateControls  = 'Desactivating controls... ';
  sStartingResolution   = 'Starting resolution';
  sProcessingTime       = 'Processing time :';
  sInfoCompleted        = 'Information completed';
  sSudokuFail           = 'I''m afraid Dave that this grid cannot be resolved';
  sDroppingNumber       = 'Dropping N%d... ';
  sCellCleared          = 'Cell cleared';
  sSuccess              = 'Success';
  sFailed               = 'Failed';
  sReady                = 'Ready';
  sReadyToPlay          = 'Drop a few numbers or OPEN a file'#13'Press IGNATION when ready';
  sStandBy              = 'Stand by';
  sNotValidFile         = 'Error: %s is not a valid file';
  sFileLoaded           = '%s loaded';
  sFileSaved            = '%s saved';
  sFileNotSaved         = 'Error while saving %s';
  sNewGrid              = 'New grid';
  sSetValueCount        = 'SetValues count : %d';

//------------------------------------------------------------------------------

implementation

{$R *.dfm}

procedure TfDisplay.Clear;
begin
  Memo1.Lines.Text := '';
end;

procedure TfDisplay.FormCreate(Sender: TObject);
begin
  DoubleBuffered := TRUE;
end;

procedure TfDisplay.Timer1Timer(Sender: TObject);
var
  s :string;
begin
  //Envoi les caractres un  un
  Timer1.Enabled := FALSE;

  if Length(Buffer) > 0 then
  begin
    //Effac ?
    if (Buffer[1] = Char(VK_CLEAR)) then
      Memo1.Lines.Text := ''
    else
    begin
      if (Memo1.Lines.Count > 8)
      then s := ''
      else s := Memo1.Lines.Text;

      insert(Buffer[1], s, Length(s));

      Memo1.Lines.Text := s;
    end;

    Delete(Buffer, 1, 1);

    Timer1.Enabled := Length(Buffer) > 0;
  end;
end;

procedure TfDisplay.Write(const aText: string; aClear: boolean);
begin
  if aClear then
    Buffer := Buffer +Char(VK_CLEAR);
    
  Buffer := Buffer +aText;
  Timer1.Enabled := TRUE;
end;

procedure TfDisplay.WriteLn(const aText: string; aClear :boolean);
begin
  Write(aText +#13, aClear);
end;

procedure TfDisplay.WriteTime(aSuffixText: string; aTime: extended);
var
  i :integer;

const
  u : array[1..4] of string = ('s', 'ms', 's', 'ns');

begin
  if aTime > Power(10, -9) then
  begin
    i := 1;

    repeat
       if aTime > 1 then
       begin
         aSuffixText := aSuffixText +' %f ' +u[i];
         WriteLn(Format(aSuffixText, [aTime]));
         Exit;
       end;

       aTime := aTime *1000;
       inc(i);
    until FALSE;
  end;
end;

end.
